# SMART tool
We propose a framework underlying decentralized social media called SMART, capable of finding relevant interest communities without violating users’ privacy and anonymity. Its objective is to improve trust and eliminate malicious actors in participatory exchanges and collaborative decision making.

## Project structure
The five folders *data-hub*, *message-broker*, *rest-gateway*, *transaction-hub-in* and *transaction-hub-out* contain the microservices for the five architecture layers respectively.

The *modules* folder contains various Python modules used by multiple microservices to improve code-reuse. When building the Docker images this folder is copied into the app path.

The *tools* folder contains supportive scripts used during development and must not be used by any microservice.

The scripts *build.py* and *deploy.py* are used to create Docker images and deploy these images in Kubernetes respectively.

The *images* folder holds the images used in this document.

## Overall microservice architecture
![SMART architecture image](images/smart-architecture.png)

